; *********************************************************************************
print_version:
    ldi     ZH, high(version*2)
    ldi     ZL, low(version*2)
    ldi     Temp3, 16
    rjmp    PRINT_DS18x20_string

; *********************************************************************************
print_family_code:
    ldi     Temp1, LCD_Line1                ; setze LCD auf Line1
    rcall   LCD_Cmd             
    ldi     temp1, 'I'
    rcall   LCD_Data
    ldi     temp1, 'D'
    rcall   LCD_Data
    ldi     ZH, high(ID_Family_Code)
    ldi     ZL, low(ID_Family_Code)
    ldi     Temp0, 4
    rjmp    print_lcd

; ********************************************************************************* 
print_temp_data:
    ldi     Temp1, LCD_Line1                ; setze LCD auf Line1
    rcall   LCD_Cmd
    ldi     temp1, 'S'
    rcall   LCD_Data
    ldi     temp1, 'P'
    rcall   LCD_Data
    ldi     ZH, high(SP_Temp_LSB)
    ldi     ZL, low(SP_Temp_LSB)
    ldi     Temp0, 5

; ********************************************************************************* 
print_lcd:
    rcall   print_line_loop
    ldi     Temp1, LCD_Line2                ; setze LCD auf Line2
    rcall   LCD_Cmd
    ldi     temp1, ' '
    rcall   LCD_Data
    ldi     temp1, ' '
    rcall   LCD_Data
    ldi     Temp0, 4
    rcall   print_line_loop
    ret

; ********************************************************************************* 
print_line_loop:
    ld      Temp1, Z+                       ; Nchstes Byte per Pointer laden und Pointer erhhen
    rcall   HEX2ASCII                       ; in ASCII umwandlen und ausgeben
    dec     Temp0
    brne    print_line_loop
    ret

; ********************************************************************************* 
HEX2ASCII:                                  ; HEX --> ASCII (2 digit) + Ausgabe
    push    Temp1                           ; Temp1 sichern
    swap    Temp1                           ; Nibbles tauschen
    andi    Temp1, 0x0F                     ; unteres Nibble maskieren
    rcall   Hex2Asci_digit                  ; in ASCII umwandeln und ausgeben
    pop     Temp1                           ; Temp1 zurckholen
    andi    Temp1, 0x0F                     ; unteres Nibble maskieren
Hex2Asci_digit:                             ; in ASCII umwandeln und ausgeben
    subi    Temp1, -'0'                     ; +'0'
    cpi     Temp1, '9' + 1                  ; teste auf grsser als '9'
    brlo    Hex2Asci_end
    subi    Temp1, -('A'-'9'-1)             ; addiere Differenz zu ASCII 'A'
Hex2Asci_end:       
    rcall   LCD_Data
    ret

; *********************************************************************************
Text_line_1:    .db     " DS18_20 F: "
; ---------------------------------------------------------------------------------
; Typ vom Temperatursensor ausgeben
; 
PRINT_DS18x20_TYPE:
; ---------------------------------------------------------------------------------
    ldi     Temp1, LCD_Line1                ; setze LCD auf Line1
    rcall   LCD_Cmd

    ldi     ZH, high(Text_line_1 *2)        ; Pointer laden
    ldi     ZL, low(Text_line_1 *2)         ; LPM braucht Byte-Adresse, darum *2
    ldi     Temp3, 12                       ; Anzahl Zeichen
	rcall	PRINT_DS18x20_string			; String ausgeben
    ldi     Temp1, LCD_Line1+5              ; setze LCD auf Line1 +5
    rcall   LCD_Cmd

    lds     Temp2, ID_Family_Code           ; prfe family code
    cpi     Temp2, 0x10                     ; test auf 
    breq    DS18_S_20                       ; 0x10 = DS18S20
    cpi     Temp2, 0x28                     ; test auf 
    breq    DS18_B_20                       ; 0x28 = DS18B20
    ldi     Temp1, '?'                      ; unbekannter IC
    rjmp    PRINT_DS18x20_TYPE_end
DS18_B_20:  
    ldi     Temp1, 'B'
    rjmp    PRINT_DS18x20_TYPE_end
DS18_S_20:  
    ldi     Temp1, 'S'
PRINT_DS18x20_TYPE_end:
    rcall   LCD_Data
    ret

; *********************************************************************************
PRINT_DS18x20_string:						; String aus Flash ausgeben
; Paramter: Z: Zeiger auf String; temp1: Bytezhler
; ---------------------------------------------------------------------------------
    lpm     Temp1, Z+
    rcall   LCD_Data
    dec     Temp3
    brne    PRINT_DS18x20_string
	ret

; *********************************************************************************
PRINT_DS18x20_error:
; Fehlerbits einzeln ausgeben
; ---------------------------------------------------------------------------------
    ldi     Temp1, LCD_Line1+11             ; Cursor auf Line1+11 setzen 
    rcall   LCD_Cmd

    ldi     temp0, 4                        ; Bitzhler             
    mov     temp2, Fehler
    swap    temp2                           ; Fehlerbits ins obere Nibble
PRINT_DS18x20_error_loop:
    ldi     temp1, '0'                      ; einzeln als 0 oder 1 ausgeben
    lsl     temp2
    brcc    PRINT_DS18x20_error_0
    ldi     temp1, '1'
PRINT_DS18x20_error_0:
    rcall   LCD_Data    
    dec     temp0
    brne    PRINT_DS18x20_error_loop
    ret

; *********************************************************************************
